//#define _MPC
#define _PCI

#define DRIVER_VERSION 30409

#include <linux/ioctl.h>
#include <linux/fs.h>
#include <linux/version.h>

#ifndef KERNEL_VERSION
#define KERNEL_VERSION(a,b,c) ( ((a)<16) | ((b)<8) | (c) )
#endif


#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 5, 0)
#include <linux/moduleparam.h>
#include <linux/device.h>
#include <linux/workqueue.h>
#else
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
#include <linux/tqueue.h>
#endif
#endif


#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
#include <linux/wait.h> // for DECLARE_WAIT_QUEUE_HEAD
#include <linux/spinlock.h> // struct spinlock_t
#else
#include <asm/spinlock.h> // struct spinlock_t
#endif

#include "commdef_mxc6xxxdio.h"

#if defined(_MPC)
	#define	 MAX_MPC_CARDS	4
#elif defined(_PCI)
	#define	  PCI_PORT_MAX    4
#endif

#define 	ENABLE    1
#define		DISABLE	  0

#define   HIBYTE(ax)      (ax >> 8)
#define   LOBYTE(ax)      (ax & 0x00ff)
#define   HIWORD(ax)      (ax >> 16)
#define   LOWORD(ax)      (ax & 0x0000ffff)

/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/
// Constant for structures
// Port report from PCI bios
#define		PCI_CTRL_S593		0
#define		PCI_CTRL_PLX90		1
#define		PCI_CTRL_P9080		2
#define		PCI_CTRL_HSL_P9050	3
/*------------------------------------------------------------------*/

typedef struct
{
	U16    wCard;
	U16    busNo;
	U16    devFunc;
	U32    lcrBase;
	U32    baseAddr;
	U16    initFlag;
	SH_MEM Alloc;
	U16    irqNo;
	Boolean IsrEnable;
	U16    Reference;
	struct fasync_struct *async_queue1, *async_queue2,*async_queue3, *async_queue4;
	U16    W8164_int_axis;
	U32    W8164_int_status_error[4];
	U32    W8164_int_status_event[4];

	U16 PLX_USR[2];
	U16 VERSION;
	U16 DRV_VERSION;

	U32    Address0;
	U32    Size0;
	U32    MemAddress0;
	U32    MemSize0;

} PCI_Info;

void adl_kill_fasync(struct fasync_struct *fa, int sig);
U32 translate_kvirt_addr( U32 user_virt_addr );
#if defined(_PCI)
int AdlFindDevice( U16 VendorID, U16 DeviceID, U16 PciController );
#elif defined(_MPC)
int AdlFindDevice(void);
#endif
