#!/bin/sh
#set -e

export KVERSION=$1
NAME=$2
VERSION=$3


git_newest_neon_driver() {

	NEON_GIT_PATH=""
	
	chmod 600 /root/.ssh/id_rsa
	git clone $NEON_GIT_PATH /usr/src/tmp_clone

	if [ $? -ne 0 ]; then
		exit 1;
	else

		if [ -d "/usr/src/tmp_clone" ] && [ -d "/usr/src/$NAME-$VERSION" ]; then
			cp -r /usr/src/$NAME-$VERSION /usr/src/$NAME-$VERSION-backup
			cp -r /usr/src/tmp_clone/* /usr/src/$NAME-$VERSION/
			cp -r /usr/src/tmp_clone/* /var/lib/dkms/$NAME/$VERSION/source/
			cp -r /usr/src/tmp_clone/* /var/lib/dkms/$NAME/$VERSION/build/
	
			make all -f Makefile
			#$(shell dkms install $NAME/$VERSION)
	
		else
			echo "ADLINK Info: dkms-build fail on the current kernel."
			echo "ADLINK Warring: Get the newest neon driver fail , please check the   
interrent setting or contact ADLINK Co., Ltd"
		fi

		rm -r /usr/src/tmp_clone/

	fi

	rm -r /usr/src/tmp_clone/
}

neon_make() {
	echo "ADLINK: neon_make"

	#make all $KVERSION -f Makefile >/dev/null
	make build_source -f Makefile >/dev/null

	#echo "$?"

	if [ $? -ne 0 ]; then	

	   #If Make failed, run Make again with the newest neon driver
#	   git_newest_neon_driver
	   exit 0;

	else
	   echo "ADLINK: neon_make is ok."
	fi
}

attached_file() {
	sudo chmod 755 /usr/src/$NAME-$VERSION/debian_file/usr/bin/*
	sudo cp -rf /usr/src/$NAME-$VERSION/debian_file/* /
}

echo "neon shell build...."
neon_make
attached_file
echo "neon build done"
